
c------------------------------------------------------------------------

c --> calculation of unphysical parameters from physical parameters
c     for one sfermion type
      subroutine def4b(msf1, msf2, stf, mf, qf, xtb, msusyl,msusyr,xf,f)

c     f = 1: top-type fermions
c     f = 2: bottom type fermions

      double precision msf1, msf2, stf, mf, qf,
     $                 msusyl, msusyr, xf, msusyl2, msusyr2
      double precision xmw,xmz,xmt,xtb,xb,xc2b,xsw2,dt1,dt2
      double precision rot(1:2,1:2), rottrans(1:2,1:2), 
     $                 mdiag(1:2,1:2), mnondiag(1:2,1:2), z(1:2,1:2)
      integer f

      common /smpara1/ xmw,xmz,xmt

c      write(*,*) 'Parameters in def4b:',
c     $     real(msf1), real(msf2), real(stf), real(mf), real(qf), 
c     $     real(xtb)

      xb = datan(xtb)
      xc2b = dcos(2d0*xb)
      xsw2 = 1d0 - xmw**2/xmz**2
      if (f.eq.1) then
         dt1 = xmz**2 * xc2b * (.5d0 - qf * xsw2)
         dt2 = xmz**2 * xc2b * (       qf * xsw2)
      elseif (f.eq.2) then
         dt1 = xmz**2 * xc2b * (-.5d0 - qf * xsw2)
         dt2 = xmz**2 * xc2b * (        qf * xsw2)
      else
         write(*,*) 'Error in def4b: sfermion selection'
      endif

      mdiag(1,1) = msf1**2
      mdiag(1,2) = 0d0
      mdiag(2,1) = 0d0
      mdiag(2,2) = msf2**2
      ctf = dsqrt(1d0 - stf**2)
      rot(1,1) = ctf
      rot(1,2) = stf
      rot(2,1) = -stf
      rot(2,2) = ctf
      rottrans(1,1) = ctf
      rottrans(1,2) = -stf
      rottrans(2,1) = stf
      rottrans(2,2) = ctf

      call diagonalization(rottrans, mdiag, rot, mnondiag)

      msusyl2 = mnondiag(1,1) - mf**2 - dt1
      msusyr2 = mnondiag(2,2) - mf**2 - dt2
      if ((msusyl2.ge.0d0).and.(msusyr2.ge.0d0)) then
         msusyl = dsqrt(mnondiag(1,1) - mf**2 - dt1)
         msusyr = dsqrt(mnondiag(2,2) - mf**2 - dt2)
         xf = mnondiag(1,2)/mf
      else
         msusyl = 0d0
         msusyr = 0d0
         xf = 0d0
      endif

c      write(*,*) 'parameters from def4b:',
c     $           real(msusyl), real(msusyr), real(xf)
c      write(*,*) real(mnondiag(1,1)), real(mnondiag(1,2)),
c     $           real(mnondiag(2,1)), real(mnondiag(2,2))

      end
